﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals
	
	Private Layers As List	'of Layer
	Private LearningRate As Double
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(vLearningRate As Double,nLayers As List)
	
	If nLayers.Size < 2 Then
		Return
	End If
	
	LearningRate=vLearningRate
	Layers.Initialize
	
	Dim I,J,K,K1 As Int
	For I = 0 To nLayers.Size-1
		Dim L As Layer
		L.Initialize(nLayers.Get(I)-1)
		Layers.Add(L)
		
		For J = 0 To nLayers.Get(I)-1
			L.AddNeuron
		Next
		
		For K = 0 To L.GetNeuronSize-1
			Dim N As Neuron = L.GetNeuron(K)
			
			If I = 0 Then
				N.SetBias(0)
			Else
				For K1 = 0 To nLayers.Get(I-1)-1
					N.AddDendrite
				Next
			End If
			
		Next
	Next
	
End Sub

Public Sub GetLayer(Ind As Int) As Layer
	Return Layers.Get(Ind)
End Sub
Public Sub GetLayers As List
	Return Layers
End Sub
Public Sub SetLayers(Val As List)
	Layers=Val
End Sub

Public Sub GetLearningRate As Double
	Return LearningRate
End Sub
Public Sub SetLearningRate(Val As Double)
	LearningRate=Val
End Sub
Public Sub GetLayerSize As Int
	Return Layers.Size
End Sub

Sub Sigmoid(X As Double) As Double
	Return 1/(1+Exp(-X))
End Sub

Sub Exp(D As Double) As Double
	Private Const e As Double = 2.71828182845905
	Return Power(e,D)
End Sub

Sub Execute(Inputs As List) As List
	
	Dim NN As NeuralNetwork = Me
	
	If Inputs.Size <> NN.GetLayer(0).GetNeuronSize Then
		Return Null
	End If
	
	Dim I As Int
	For I = 0 To NN.GetLayerSize-1
		Dim curLayer As Layer = Layers.Get(I)
		
		Dim J As Int
		For J = 0 To curLayer.GetNeuronSize-1
			Dim curNeuron As Neuron = curLayer.GetNeuron(J)
			
			If I = 0 Then
				curNeuron.SetValue(Inputs.Get(J))
			Else
				curNeuron.SetValue(0)
				
				Dim K As Int
				For K = 0 To NN.GetLayer(I-1).GetNeuronSize-1
					curNeuron.SetValue(curNeuron.GetValue + NN.GetLayer(I-1).GetNeuron(K).GetValue * curNeuron.GetDendrite(K).GetWeight)
				Next
				
				curNeuron.SetValue(Sigmoid(curNeuron.GetValue+curNeuron.GetBias))
			End If
			
		Next
	Next
	
	Dim Outputs As List
	Outputs.Initialize
	Dim La As Layer = NN.GetLayer(NN.GetLayerSize-1)
	For I = 0 To La.GetNeuronSize-1
		Outputs.Add(La.GetNeuron(I).GetValue)
	Next
	
	Return Outputs
	
End Sub

Public Sub Train(Inputs As List,Outputs As List) As Boolean
	
	Dim NN As NeuralNetwork = Me
	
	If Inputs.Size <> NN.GetLayer(0).GetNeuronSize Or Outputs.Size <> NN.GetLayer(NN.GetLayerSize-1).GetNeuronSize Then
		Return False
	End If
	
	Execute(Inputs)
	
	Dim I,J,K As Int
	For I = 0 To NN.GetLayer(NN.GetLayerSize-1).GetNeuronSize-1
		Dim curNeuron As Neuron = NN.GetLayer(NN.GetLayerSize-1).GetNeuron(I)
		
		curNeuron.SetDelta(curNeuron.GetValue*(1-curNeuron.GetValue)*(Outputs.Get(I)-curNeuron.GetValue))
		
		For J = NN.GetLayerSize-2 To 1 Step -1
			For k = 0 To NN.GetLayer(J).GetNeuronSize-1
				Dim iNeuron As Neuron = NN.GetLayer(J).GetNeuron(K)
				iNeuron.SetDelta(iNeuron.GetValue*(1-iNeuron.GetValue)*NN.GetLayer(J+1).GetNeuron(I).GetDendrite(K).GetWeight*NN.GetLayer(J+1).GetNeuron(I).GetDelta)
			Next
		Next
		
	Next
	
	For I = NN.GetLayerSize-1 To 0 Step -1
		For j = 0 To NN.GetLayer(I).GetNeuronSize-1
			Dim iNeuron As Neuron = NN.GetLayer(I).GetNeuron(J)
			iNeuron.SetBias(iNeuron.GetBias+(NN.GetLearningRate*iNeuron.GetDelta))
			
			For K = 0 To iNeuron.GetDendriteSize-1
				iNeuron.GetDendrite(K).SetWeight(iNeuron.GetDendrite(K).GetWeight+(NN.GetLearningRate*NN.GetLayer(I-1).GetNeuron(K).GetValue*iNeuron.GetDelta))
			Next
		Next
	Next
	
	Return True
	
End Sub